//+------------------------------------------------------------------+
//|                                         Belomor Trend Factor.mq4 |
//|                                                          Belomor |
//|                                                 belomor@inbox.ru |
//+------------------------------------------------------------------+
#property copyright "Belomor"
#property link      "belomor@inbox.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Silver
#property indicator_color2 Yellow
//---- input parameters
extern int       BTF=13;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   IndicatorShortName("Belomor Trend Factor ("+BTF+")");
   SetIndexDrawBegin(0,BTF+34);
   SetIndexDrawBegin(1,BTF+34);
   SetIndexLabel(0,"Trend Line");
   SetIndexLabel(1,"Expect Line");
   IndicatorDigits(2);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      {
      ExtMapBuffer4[i]=iAO(NULL,0,i);
      ExtMapBuffer3[i]=iAC(NULL,0,i);
      }
   for(i=0; i<limit; i++)
      {
      ExtMapBuffer2[i]=2*iRSIOnArray(ExtMapBuffer3,Bars,BTF,i)-100;
      ExtMapBuffer1[i]=2*iRSIOnArray(ExtMapBuffer4,Bars,BTF,i)-100;
      }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+